# Progress

This currently only lists views.

Table columns:

- Status
  - blank: not started
  - 🚧: some features work
  - ✅: feature-complete
- Name of view

## Views and Controls

### Text

|     |                                                                              |     |
| --- | ---------------------------------------------------------------------------- | :-: |
| 🚧  | [Text](https://developer.apple.com/documentation/swiftui/text)               |     |
| 🚧  | [TextField](https://developer.apple.com/documentation/swiftui/textfield)     |     |
| 🚧  | [SecureField](https://developer.apple.com/documentation/swiftui/securefield) |     |
| ✅  | [TextEditor](https://developer.apple.com/documentation/swiftui/texteditor)   |     |

### Images

|     |                                                                  |     |
| --- | ---------------------------------------------------------------- | :-: |
| 🚧  | [Image](https://developer.apple.com/documentation/swiftui/image) |     |

### Buttons

|     |                                                                                                  |     |
| --- | ------------------------------------------------------------------------------------------------ | :-: |
| 🚧  | [Button](https://developer.apple.com/documentation/swiftui/button)                               |     |
| 🚧  | [NavigationLink](https://developer.apple.com/documentation/swiftui/navigationlink)               |     |
|     | [EditButton](https://developer.apple.com/documentation/swiftui/editbutton)                       |     |
|     | [PasteButton](https://developer.apple.com/documentation/swiftui/pastebutton)                     |     |
|     | [SignInWithAppleButton](https://developer.apple.com/documentation/swiftui/signinwithapplebutton) |     |
|     | [Menu](https://developer.apple.com/documentation/swiftui/menu)                                   |     |

### Value Selectors

|     |                                                                              |     |
| --- | ---------------------------------------------------------------------------- | :-: |
| 🚧  | [Toggle](https://developer.apple.com/documentation/swiftui/toggle)           |     |
| 🚧  | [Picker](https://developer.apple.com/documentation/swiftui/picker)           |     |
| 🚧  | [DatePicker](https://developer.apple.com/documentation/swiftui/datepicker)   |     |
| 🚧  | [Slider](https://developer.apple.com/documentation/swiftui/slider)           |     |
|     | [Stepper](https://developer.apple.com/documentation/swiftui/stepper)         |     |
|     | [ColorPicker](https://developer.apple.com/documentation/swiftui/colorpicker) |     |

### Value Indicators

|     |                                                                                |     |
| --- | ------------------------------------------------------------------------------ | :-: |
|     | [ProgressView](https://developer.apple.com/documentation/swiftui/progressview) |     |
|     | [Gauge](https://developer.apple.com/documentation/swiftui/gauge)               |     |
|     | [Label](https://developer.apple.com/documentation/swiftui/label)               |     |
| ✅  | [Link](https://developer.apple.com/documentation/swiftui/link)                 |     |

## View Layout and Presentation

### Stacks

|     |                                                                            |     |
| --- | -------------------------------------------------------------------------- | :-: |
| 🚧  | [HStack](https://developer.apple.com/documentation/swiftui/hstack)         |     |
| 🚧  | [VStack](https://developer.apple.com/documentation/swiftui/vstack)         |     |
| 🚧  | [ZStack](https://developer.apple.com/documentation/swiftui/zstack)         |     |
|     | [LazyHStack](https://developer.apple.com/documentation/swiftui/lazyhstack) |     |
|     | [LazyVStack](https://developer.apple.com/documentation/swiftui/lazyvstack) |     |

### Grids

|     |                                                                          |     |
| --- | ------------------------------------------------------------------------ | :-: |
| 🚧  | [LazyHGrid](https://developer.apple.com/documentation/swiftui/lazyhgrid) |     |
| 🚧  | [LazyVGrid](https://developer.apple.com/documentation/swiftui/lazyvgrid) |     |
| 🚧  | [GridItem](https://developer.apple.com/documentation/swiftui/griditem)   |     |

### Lists and Scroll Views

|     |                                                                                            |     |
| --- | ------------------------------------------------------------------------------------------ | :-: |
| 🚧  | [List](https://developer.apple.com/documentation/swiftui/list)                             |     |
| 🚧  | [ForEach](https://developer.apple.com/documentation/swiftui/foreach)                       |     |
| 🚧  | [ScrollView](https://developer.apple.com/documentation/swiftui/scrollview)                 |     |
|     | [ScrollViewReader](https://developer.apple.com/documentation/swiftui/scrollviewreader)     |     |
|     | [ScrollViewProxy](https://developer.apple.com/documentation/swiftui/scrollviewproxy)       |     |
|     | [DynamicViewContent](https://developer.apple.com/documentation/swiftui/dynamicviewcontent) |     |

### Container Views

|     |                                                                        |     |
| --- | ---------------------------------------------------------------------- | :-: |
|     | [Form](https://developer.apple.com/documentation/swiftui/form)         |     |
| ✅  | [Group](https://developer.apple.com/documentation/swiftui/group)       |     |
|     | [GroupBox](https://developer.apple.com/documentation/swiftui/groupbox) |     |
| 🚧  | [Section](https://developer.apple.com/documentation/swiftui/section)   |     |

### Hierarchical Views

|     |                                                                                      |     |
| --- | ------------------------------------------------------------------------------------ | :-: |
| 🚧  | [OutlineGroup](https://developer.apple.com/documentation/swiftui/outlinegroup)       |     |
| 🚧  | [DisclosureGroup](https://developer.apple.com/documentation/swiftui/disclosuregroup) |     |

### Spacers and Dividers

|     |                                                                      |     |
| --- | -------------------------------------------------------------------- | :-: |
| ✅  | [Spacer](https://developer.apple.com/documentation/swiftui/spacer)   |     |
|     | [Divider](https://developer.apple.com/documentation/swiftui/divider) |     |

### Architectural Views

|     |                                                                                    |     |
| --- | ---------------------------------------------------------------------------------- | :-: |
| 🚧  | [NavigationView](https://developer.apple.com/documentation/swiftui/navigationview) |     |
|     | [TabView](https://developer.apple.com/documentation/swiftui/tabview)               |     |
|     | [HSplitView](https://developer.apple.com/documentation/swiftui/hsplitview)         |     |
|     | [VSplitView](https://developer.apple.com/documentation/swiftui/vsplitview)         |     |

### Conditionally Visible Items

|     |                                                                                  |     |
| --- | -------------------------------------------------------------------------------- | :-: |
| ✅  | [EmptyView](https://developer.apple.com/documentation/swiftui/emptyview)         |     |
|     | [EquatableView](https://developer.apple.com/documentation/swiftui/equatableview) |     |

### Infrequently Used Views

|     |                                                                          |     |
| --- | ------------------------------------------------------------------------ | :-: |
| ✅  | [AnyView](https://developer.apple.com/documentation/swiftui/anyview)     |     |
| ✅  | [TupleView](https://developer.apple.com/documentation/swiftui/tupleview) |     |

## Shapes, Paths, and Styles

### Shapes

|     |                                                                                        |     |
| --- | -------------------------------------------------------------------------------------- | :-: |
| 🚧  | [Rectangle](https://developer.apple.com/documentation/swiftui/rectangle)               |     |
| 🚧  | [RoundedRectangle](https://developer.apple.com/documentation/swiftui/roundedrectangle) |     |
| 🚧  | [Ellipse](https://developer.apple.com/documentation/swiftui/ellipse)                   |     |
| 🚧  | [Circle](https://developer.apple.com/documentation/swiftui/circle)                     |     |
| 🚧  | [Capsule](https://developer.apple.com/documentation/swiftui/capsule)                   |     |

### Paths

|     |                                                                |     |
| --- | -------------------------------------------------------------- | :-: |
| 🚧  | [Path](https://developer.apple.com/documentation/swiftui/path) |     |

### Styles

|     |                                                                  |     |
| --- | ---------------------------------------------------------------- | :-: |
| 🚧  | [Color](https://developer.apple.com/documentation/swiftui/color) |     |
